Package ghidra.trace.database

# Class DBTrace

java.lang.Object
ghidra.framework.data.DomainObjectAdapter
ghidra.framework.data.DomainObjectAdapterDB
ghidra.framework.data.DBDomainObjectSupport
ghidra.util.database.DBCachedDomainObjectAdapter
ghidra.trace.database.DBTrace

All Implemented Interfaces:
  `ErrorHandler`, `DataTypeManagerOwner`, `DomainObject`, `DataTypeManagerDomainObject`, `Trace`, `TraceChangeManager`

public class DBTrace extends DBCachedDomainObjectAdapter implements Trace, TraceChangeManager

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class ghidra.framework.data.DBDomainObjectSupport

  `DBDomainObjectSupport.ManagerSupplier<T>`

  ## Nested classes/interfaces inherited from interface ghidra.trace.model.Trace

  `Trace.TraceProgramViewListener`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected DBTraceAddressPropertyManager`
  `addressPropertyManager`
  `protected static final String`
  `BASE_COMPILER`
  `protected static final String`
  `BASE_LANGUAGE`
  `protected TraceAddressFactory`
  `baseAddressFactory`
  `protected CompilerSpec`
  `baseCompilerSpec`
  `protected Language`
  `baseLanguage`
  `protected DBTraceBookmarkManager`
  `bookmarkManager`
  `protected DBTraceBreakpointManager`
  `breakpointManager`
  `protected DBTraceCodeManager`
  `codeManager`
  `protected DBTraceCommentAdapter`
  `commentAdapter`
  `protected DBTraceDataSettingsAdapter`
  `dataSettingsAdapter`
  `protected DBTraceDataTypeManager`
  `dataTypeManager`
  `protected static final String`
  `DATE_CREATED`
  `protected static final int`
  `DB_BUFFER_SIZE`
  `protected static final int`
  `DB_TIME_INTERVAL`
  `protected ListenerSet<DBTraceDirectChangeListener>`
  `directListeners`
  `protected static final String`
  `EMU_CACHE_VERSION`
  `protected DBTraceEquateManager`
  `equateManager`
  `protected static final String`
  `EXECUTABLE_PATH`
  `protected Map<Long,DBTraceProgramView>`
  `fixedProgramViews`
  `protected List<DBTraceManager>`
  `managers`
  `protected DBTraceMemoryManager`
  `memoryManager`
  `protected DBTraceModuleManager`
  `moduleManager`
  `protected static final String`
  `NAME`
  `protected DBTraceObjectManager`
  `objectManager`
  `protected DBTraceOverlaySpaceAdapter`
  `overlaySpaceAdapter`
  `protected static final String`
  `PLATFORM`
  `protected DBTracePlatformManager`
  `platformManager`
  `protected DBTraceVariableSnapProgramView`
  `programView`
  `protected Set<DBTraceVariableSnapProgramView>`
  `programViews`
  `protected Set<TraceProgramView>`
  `programViewsView`
  `protected boolean`
  `recordChanges`
  `protected DBTraceReferenceManager`
  `referenceManager`
  `protected DBTraceRegisterContextManager`
  `registerContextManager`
  `protected DBTraceStackManager`
  `stackManager`
  `protected DBTraceStaticMappingManager`
  `staticMappingManager`
  `protected DBTraceSymbolManager`
  `symbolManager`
  `protected DBTraceThreadManager`
  `threadManager`
  `protected DBTraceTimeManager`
  `timeManager`
  `protected static final String`
  `TRACE_INFO`
  `protected DBTraceChangeSet`
  `traceChangeSet`
  `protected ListenerSet<Trace.TraceProgramViewListener>`
  `viewListeners`
  `protected Set<DBTraceTimeViewport>`
  `viewports`

  ### Fields inherited from class ghidra.util.database.DBCachedDomainObjectAdapter

  `rwLock`

  ### Fields inherited from class ghidra.framework.data.DomainObjectAdapterDB

  `changeSet, dbh, NUM_UNDOS, options`

  ### Fields inherited from class ghidra.framework.data.DomainObjectAdapter

  `changed, changeSupportMap, DEFAULT_NAME, lock, metadata, name, temporary`

  ### Fields inherited from interface ghidra.framework.model.DomainObject

  `DO_DOMAIN_FILE_CHANGED, DO_OBJECT_CLOSED, DO_OBJECT_ERROR, DO_OBJECT_RENAMED, DO_OBJECT_RESTORED, DO_OBJECT_SAVED, DO_PROPERTY_CHANGED, undoLock`

  ### Fields inherited from interface ghidra.trace.model.Trace

  `TRACE_ICON`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DBTrace(DBHandle dbh, OpenMode openMode, TaskMonitor monitor, Object consumer)`
  `DBTrace(String name, CompilerSpec baseCompilerSpec, Object consumer)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addDirectChangeListener(DBTraceDirectChangeListener listener)`
  `void`
  `addProgramViewListener(Trace.TraceProgramViewListener listener)`
  `protected void`
  `allViewports(Consumer<DBTraceTimeViewport> action)`
  `protected void`
  `allViews(Consumer<DBTraceProgramView> action)`
  `void`
  `assertValidAddress(Address pc)`
  `void`
  `assertValidSpace(AddressSpace as)`
  `void`
  `categoryAdded(long addedID, Category addedCategory)`
  `void`
  `categoryDeleted(long deletedID, CategoryPath deletedPath)`
  `void`
  `categoryMoved(long movedID, CategoryPath oldPath, CategoryPath newPath)`
  `void`
  `categoryRenamed(long renamedID, String oldName, String newName)`
  `protected void`
  `clearCache(boolean all)`
  `protected void`
  `close()`
  `protected DBTraceAddressPropertyManager`
  `createAddressPropertyManager(DBTraceThreadManager threadManager)`
  `protected DBTraceBookmarkManager`
  `createBookmarkManager(DBTraceThreadManager threadManager)`
  `protected DBTraceBreakpointManager`
  `createBreakpointManager(DBTraceObjectManager objectManager)`
  `protected DBTraceCodeManager`
  `createCodeManager(DBTraceThreadManager threadManager, DBTracePlatformManager platformManager, DBTraceDataTypeManager dataTypeManager, DBTraceOverlaySpaceAdapter overlayAdapter, DBTraceReferenceManager referenceManager)`
  `protected DBTraceCommentAdapter`
  `createCommentAdapter(DBTraceThreadManager threadManager)`
  `protected DBTraceDataSettingsAdapter`
  `createDataSettingsAdapter(DBTraceThreadManager threadManager)`
  `protected DBTraceDataTypeManager`
  `createDataTypeManager(DBTracePlatformManager platformManager)`
  `protected DBTraceEquateManager`
  `createEquateManager(DBTraceThreadManager threadManager)`
  `protected DBTraceMemoryManager`
  `createMemoryManager(DBTraceThreadManager threadManager, DBTraceOverlaySpaceAdapter overlayAdapter)`
  `protected DBTraceModuleManager`
  `createModuleManager(DBTraceObjectManager objectManager)`
  `protected DBTraceObjectManager`
  `createObjectManager()`
  `protected DBTraceOverlaySpaceAdapter`
  `createOverlaySpaceAdapter()`
  `protected DBTracePlatformManager`
  `createPlatformManager()`
  `DBTraceVariableSnapProgramView`
  `createProgramView(long snap)`
  `protected DBTraceReferenceManager`
  `createReferenceManager(DBTraceThreadManager threadManager, DBTraceOverlaySpaceAdapter overlayAdapter)`
  `protected DBTraceRegisterContextManager`
  `createRegisterContextManager(DBTraceThreadManager threadManager, DBTracePlatformManager platformManager)`
  `protected DBTraceStackManager`
  `createStackManager(DBTraceThreadManager threadManager, DBTraceOverlaySpaceAdapter overlayAdapter)`
  `protected DBTraceStaticMappingManager`
  `createStaticMappingManager(DBTraceOverlaySpaceAdapter overlayAdapter)`
  `protected DBTraceSymbolManager`
  `createSymbolManager(DBTraceThreadManager threadManager, DBTraceDataTypeManager dataTypeManager, DBTraceOverlaySpaceAdapter overlayAdapter)`
  `protected DBTraceThreadManager`
  `createThreadManager(DBTraceObjectManager objectManager)`
  `protected DBTraceTimeManager`
  `createTimeManager(DBTraceThreadManager threadManager)`
  `DBTraceTimeViewport`
  `createTimeViewport()`
  `protected <T extends DBTraceManager>
  T`
  `createTraceManager(String managerName, DBDomainObjectSupport.ManagerSupplier<T> supplier)`
  `void`
  `dataTypeAdded(long addedID, DataType addedType)`
  `void`
  `dataTypeChanged(long changedID, DataType changedType)`
  `void`
  `dataTypeDeleted(long deletedID, DataTypePath deletedPath)`
  `void`
  `dataTypeMoved(long movedID, DataTypePath oldPath, DataTypePath newPath)`
  `void`
  `dataTypeNameChanged(long renamedID, String oldName, String newName)`
  `void`
  `dataTypeReplaced(long replacedID, DataTypePath replacedPath, DataTypePath newPath)`
  `void`
  `dbError(IOException e)`
  Notification that an IO exception occurred.
  `protected void`
  `domainObjectRestored()`
  Indicates that this domain object has been restored to a completely different state due to a transaction undo/redo/rollback or a database merge operation.
  `void`
  `fireEvent(DomainObjectChangeRecord ev)`
  Fires the specified event.
  `TraceAddressPropertyManager`
  `getAddressPropertyManager()`
  `Collection<TraceProgramView>`
  `getAllProgramViews()`
  Collect all program views, fixed or variable, of this trace.
  `AddressFactory`
  `getBaseAddressFactory()`
  `CompilerSpec`
  `getBaseCompilerSpec()`
  `DBTraceDataTypeManager`
  `getBaseDataTypeManager()`
  `Language`
  `getBaseLanguage()`
  `DBTraceBookmarkManager`
  `getBookmarkManager()`
  `DBTraceBreakpointManager`
  `getBreakpointManager()`
  `DBTraceChangeSet`
  `getChangeSet()`
  Returns the change set corresponding to all unsaved changes in this domain object.
  `DBTraceCodeManager`
  `getCodeManager()`
  `DBTraceCommentAdapter`
  `getCommentAdapter()`
  `Date`
  `getCreationDate()`
  `DBTraceDataSettingsAdapter`
  `getDataSettingsAdapter()`
  `String`
  `getDescription()`
  Returns a word or short phrase that best describes or categorizes the object in terms that a user will understand.
  `long`
  `getEmulatorCacheVersion()`
  `DBTraceEquateManager`
  `getEquateManager()`
  `String`
  `getExecutablePath()`
  `DBTraceProgramView`
  `getFixedProgramView(long snap)`
  `TraceAddressFactory`
  `getInternalAddressFactory()`
  `DBTraceAddressPropertyManager`
  `getInternalAddressPropertyManager()`
  `DBTraceMemoryManager`
  `getMemoryManager()`
  `DBTraceModuleManager`
  `getModuleManager()`
  `DBTraceObjectManager`
  `getObjectManager()`
  `DBTraceOverlaySpaceAdapter`
  `getOverlaySpaceAdapter()`
  `DBTracePlatformManager`
  `getPlatformManager()`
  `DBTraceVariableSnapProgramView`
  `getProgramView()`
  Get the "canonical" program view for this trace
  `DBTraceReferenceManager`
  `getReferenceManager()`
  `DBTraceRegisterContextManager`
  `getRegisterContextManager()`
  `DBTraceStackManager`
  `getStackManager()`
  `DBTraceStaticMappingManager`
  `getStaticMappingManager()`
  `DBCachedObjectStoreFactory`
  `getStoreFactory()`
  `DBTraceSymbolManager`
  `getSymbolManager()`
  `DBTraceThreadManager`
  `getThreadManager()`
  `DBTraceTimeManager`
  `getTimeManager()`
  `protected void`
  `initOptions(OpenMode openMode)`
  `boolean`
  `isChangeable()`
  Returns true if changes are permitted.
  `boolean`
  `isClosing()`
  `LockHold`
  `lockRead()`
  `LockHold`
  `lockWrite()`
  `void`
  `removeDirectChangeListener(DBTraceDirectChangeListener listener)`
  `void`
  `removeProgramViewListener(Trace.TraceProgramViewListener listener)`
  `void`
  `save(String comment, TaskMonitor monitor)`
  Saves changes to the DomainFile.
  `void`
  `saveToPackedFile(File outputFile, TaskMonitor monitor)`
  Saves (i.e., serializes) the current content to a packed file.
  `protected void`
  `setChanged(boolean b)`
  `void`
  `setChanged(TraceChangeRecord<?,?> event)`
  `void`
  `setEmulatorCacheVersion(long version)`
  `void`
  `setExecutablePath(String path)`
  `protected void`
  `setTraceUserData(DBTraceUserData traceUserData)`
  `void`
  `sourceArchiveAdded(UniversalID sourceArchiveID)`
  `void`
  `sourceArchiveChanged(UniversalID sourceArchiveID)`
  `void`
  `updateViewportsSnapshotAdded(TraceSnapshot snapshot)`
  `void`
  `updateViewportsSnapshotChanged(TraceSnapshot snapshot)`
  `void`
  `updateViewportsSnapshotDeleted(TraceSnapshot snapshot)`
  `void`
  `updateViewsAddRegionBlock(TraceMemoryRegion region)`
  `void`
  `updateViewsAddSpaceBlock(AddressSpace space)`
  `void`
  `updateViewsBytesChanged(AddressRange range)`
  `void`
  `updateViewsChangeRegionBlockFlags(TraceMemoryRegion region, Lifespan lifespan)`
  `void`
  `updateViewsChangeRegionBlockLifespan(TraceMemoryRegion region, Lifespan oldLifespan, Lifespan newLifespan)`
  `void`
  `updateViewsChangeRegionBlockName(TraceMemoryRegion region)`
  `void`
  `updateViewsChangeRegionBlockRange(TraceMemoryRegion region, AddressRange oldRange, AddressRange newRange)`
  `void`
  `updateViewsDeleteRegionBlock(TraceMemoryRegion region)`
  `void`
  `updateViewsDeleteSpaceBlock(AddressSpace space)`
  `void`
  `updateViewsRefreshBlocks()`

  ### Methods inherited from class ghidra.util.database.DBCachedDomainObjectAdapter

  `getReadWriteLock`

  ### Methods inherited from class ghidra.framework.data.DBDomainObjectSupport

  `createManager, finishedCreatingManagers, init`

  ### Methods inherited from class ghidra.framework.data.DomainObjectAdapterDB

  `addSynchronizedDomainObject, addTransactionListener, canLock, canRedo, canSave, canUndo, clearUndo, clearUndo, endTransaction, flushWriteCache, forceLock, getAllRedoNames, getAllUndoNames, getCurrentTransactionInfo, getDBHandle, getOptions, getOptionsNames, getRedoName, getSynchronizedDomainObjects, getUndoName, getUndoStackDepth, getUserData, hasTerminatedTransaction, invalidate, invalidateWriteCache, isChanged, isClosed, isLocked, loadMetadata, lock, openTransaction, performPropertyListAlterations, propertyChanged, redo, releaseSynchronizedDomainObject, removeTransactionListener, saveMetadata, setImmutable, startTransaction, startTransaction, undo, unlock, updateMetadata`

  ### Methods inherited from class ghidra.framework.data.DomainObjectAdapter

  `addCloseListener, addConsumer, addDomainFileListener, addListener, checkExclusiveAccess, createPrivateEventQueue, fatalErrorOccurred, flushEvents, flushPrivateEventQueue, getAssociatedUserFilesystem, getChangeStatus, getConsumerList, getContentHandler, getContentHandler, getContentHandler, getContentHandlers, getDomainFile, getLock, getMetadata, getModificationNumber, getName, hasExclusiveAccess, isSendingEvents, isTemporary, isUsedBy, release, removeCloseListener, removeDomainFileListener, removeListener, removePrivateEventQueue, setDomainFile, setEventsEnabled, setName, setTemporary, toString`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface ghidra.framework.model.DomainObject

  `addCloseListener, addConsumer, addDomainFileListener, addListener, addSynchronizedDomainObject, addTransactionListener, canLock, canRedo, canSave, canUndo, clearUndo, createPrivateEventQueue, endTransaction, flushEvents, flushPrivateEventQueue, forceLock, getAllRedoNames, getAllUndoNames, getConsumerList, getCurrentTransactionInfo, getDomainFile, getMetadata, getModificationNumber, getName, getOptions, getOptionsNames, getRedoName, getSynchronizedDomainObjects, getUndoName, hasExclusiveAccess, hasTerminatedTransaction, isChanged, isClosed, isLocked, isSendingEvents, isTemporary, isUsedBy, lock, openTransaction, redo, release, releaseSynchronizedDomainObject, removeCloseListener, removeDomainFileListener, removeListener, removePrivateEventQueue, removeTransactionListener, setEventsEnabled, setName, setTemporary, startTransaction, startTransaction, undo, unlock, withTransaction, withTransaction`

  ### Methods inherited from interface ghidra.trace.model.Trace

  `getDataTypeManager`

- ## Field Details

  - ### TRACE_INFO

    protected static final String TRACE_INFO
    See Also:
      - Constant Field Values

  - ### NAME

    protected static final String NAME
    See Also:
      - Constant Field Values

  - ### DATE_CREATED

    protected static final String DATE_CREATED
    See Also:
      - Constant Field Values

  - ### BASE_LANGUAGE

    protected static final String BASE_LANGUAGE
    See Also:
      - Constant Field Values

  - ### BASE_COMPILER

    protected static final String BASE_COMPILER
    See Also:
      - Constant Field Values

  - ### PLATFORM

    protected static final String PLATFORM
    See Also:
      - Constant Field Values

  - ### EXECUTABLE_PATH

    protected static final String EXECUTABLE_PATH
    See Also:
      - Constant Field Values

  - ### EMU_CACHE_VERSION

    protected static final String EMU_CACHE_VERSION
    See Also:
      - Constant Field Values

  - ### DB_TIME_INTERVAL

    protected static final int DB_TIME_INTERVAL
    See Also:
      - Constant Field Values

  - ### DB_BUFFER_SIZE

    protected static final int DB_BUFFER_SIZE
    See Also:
      - Constant Field Values

  - ### managers

    protected List<DBTraceManager> managers

  - ### addressPropertyManager

    protected DBTraceAddressPropertyManager addressPropertyManager

  - ### bookmarkManager

    protected DBTraceBookmarkManager bookmarkManager

  - ### breakpointManager

    protected DBTraceBreakpointManager breakpointManager

  - ### codeManager

    protected DBTraceCodeManager codeManager

  - ### commentAdapter

    protected DBTraceCommentAdapter commentAdapter

  - ### dataSettingsAdapter

    protected DBTraceDataSettingsAdapter dataSettingsAdapter

  - ### dataTypeManager

    protected DBTraceDataTypeManager dataTypeManager

  - ### equateManager

    protected DBTraceEquateManager equateManager

  - ### platformManager

    protected DBTracePlatformManager platformManager

  - ### memoryManager

    protected DBTraceMemoryManager memoryManager

  - ### moduleManager

    protected DBTraceModuleManager moduleManager

  - ### objectManager

    protected DBTraceObjectManager objectManager

  - ### overlaySpaceAdapter

    protected DBTraceOverlaySpaceAdapter overlaySpaceAdapter

  - ### referenceManager

    protected DBTraceReferenceManager referenceManager

  - ### registerContextManager

    protected DBTraceRegisterContextManager registerContextManager

  - ### stackManager

    protected DBTraceStackManager stackManager

  - ### staticMappingManager

    protected DBTraceStaticMappingManager staticMappingManager

  - ### symbolManager

    protected DBTraceSymbolManager symbolManager

  - ### threadManager

    protected DBTraceThreadManager threadManager

  - ### timeManager

    protected DBTraceTimeManager timeManager

  - ### baseLanguage

    protected Language baseLanguage

  - ### baseCompilerSpec

    protected CompilerSpec baseCompilerSpec

  - ### baseAddressFactory

    protected TraceAddressFactory baseAddressFactory

  - ### traceChangeSet

    protected DBTraceChangeSet traceChangeSet

  - ### recordChanges

    protected boolean recordChanges

  - ### viewports

    protected Set<DBTraceTimeViewport> viewports

  - ### directListeners

    protected ListenerSet<DBTraceDirectChangeListener> directListeners

  - ### programView

    protected DBTraceVariableSnapProgramView programView

  - ### programViews

    protected Set<DBTraceVariableSnapProgramView> programViews

  - ### programViewsView

    protected Set<TraceProgramView> programViewsView

  - ### fixedProgramViews

    protected Map<Long,DBTraceProgramView> fixedProgramViews

  - ### viewListeners

    protected ListenerSet<Trace.TraceProgramViewListener> viewListeners

- ## Constructor Details

  - ### DBTrace

    public DBTrace(String name, CompilerSpec baseCompilerSpec, Object consumer) throws IOException, LanguageNotFoundException
    Throws:
      `IOException`
      `LanguageNotFoundException`

  - ### DBTrace

    public DBTrace(DBHandle dbh, OpenMode openMode, TaskMonitor monitor, Object consumer) throws CancelledException, VersionException, IOException, LanguageNotFoundException
    Throws:
      `CancelledException`
      `VersionException`
      `IOException`
      `LanguageNotFoundException`

- ## Method Details

  - ### initOptions

    protected void initOptions(OpenMode openMode) throws IOException, CancelledException
    Throws:
      `IOException`
      `CancelledException`

  - ### dbError

    public void dbError(IOException e)
    Description copied from interface: `ErrorHandler`
    Notification that an IO exception occurred.
    Specified by:
      `dbError` in interface `ErrorHandler`
    Overrides:
      `dbError` in class `DomainObjectAdapterDB`
    Parameters:
      `e` - `IOException` which was cause of error

  - ### assertValidAddress

    public void assertValidAddress(Address pc)

  - ### assertValidSpace

    public void assertValidSpace(AddressSpace as)

  - ### getChangeSet

    public DBTraceChangeSet getChangeSet()
    Description copied from class: `DomainObjectAdapterDB`
    Returns the change set corresponding to all unsaved changes in this domain object.
    Overrides:
      `getChangeSet` in class `DomainObjectAdapterDB`
    Returns:
      the change set corresponding to all unsaved changes in this domain object

  - ### getStoreFactory

    public DBCachedObjectStoreFactory getStoreFactory()

  - ### getDescription

    public String getDescription()
    Description copied from interface: `DomainObject`
    Returns a word or short phrase that best describes or categorizes the object in terms that a user will understand.
    Specified by:
      `getDescription` in interface `DomainObject`
    Specified by:
      `getDescription` in class `DomainObjectAdapter`
    Returns:
      the description

  - ### createTraceManager

    protected <T extends DBTraceManager> T createTraceManager(String managerName, DBDomainObjectSupport.ManagerSupplier<T> supplier) throws CancelledException, IOException
    Throws:
      `CancelledException`
      `IOException`

  - ### createAddressPropertyManager

    protected DBTraceAddressPropertyManager createAddressPropertyManager(DBTraceThreadManager threadManager) throws CancelledException, IOException
    Throws:
      `CancelledException`
      `IOException`

  - ### createBookmarkManager

    protected DBTraceBookmarkManager createBookmarkManager(DBTraceThreadManager threadManager) throws CancelledException, IOException
    Throws:
      `CancelledException`
      `IOException`

  - ### createBreakpointManager

    protected DBTraceBreakpointManager createBreakpointManager(DBTraceObjectManager objectManager) throws CancelledException, IOException
    Throws:
      `CancelledException`
      `IOException`

  - ### createCodeManager

    protected DBTraceCodeManager createCodeManager(DBTraceThreadManager threadManager, DBTracePlatformManager platformManager, DBTraceDataTypeManager dataTypeManager, DBTraceOverlaySpaceAdapter overlayAdapter, DBTraceReferenceManager referenceManager) throws CancelledException, IOException
    Throws:
      `CancelledException`
      `IOException`

  - ### createCommentAdapter

    protected DBTraceCommentAdapter createCommentAdapter(DBTraceThreadManager threadManager) throws CancelledException, IOException
    Throws:
      `CancelledException`
      `IOException`

  - ### createDataSettingsAdapter

    protected DBTraceDataSettingsAdapter createDataSettingsAdapter(DBTraceThreadManager threadManager) throws CancelledException, IOException
    Throws:
      `CancelledException`
      `IOException`

  - ### createDataTypeManager

    protected DBTraceDataTypeManager createDataTypeManager(DBTracePlatformManager platformManager) throws CancelledException, IOException
    Throws:
      `CancelledException`
      `IOException`

  - ### createEquateManager

    protected DBTraceEquateManager createEquateManager(DBTraceThreadManager threadManager) throws CancelledException, IOException
    Throws:
      `CancelledException`
      `IOException`

  - ### createPlatformManager

    protected DBTracePlatformManager createPlatformManager() throws CancelledException, IOException
    Throws:
      `CancelledException`
      `IOException`

  - ### createMemoryManager

    protected DBTraceMemoryManager createMemoryManager(DBTraceThreadManager threadManager, DBTraceOverlaySpaceAdapter overlayAdapter) throws IOException, CancelledException
    Throws:
      `IOException`
      `CancelledException`

  - ### createModuleManager

    protected DBTraceModuleManager createModuleManager(DBTraceObjectManager objectManager) throws CancelledException, IOException
    Throws:
      `CancelledException`
      `IOException`

  - ### createObjectManager

    protected DBTraceObjectManager createObjectManager() throws CancelledException, IOException
    Throws:
      `CancelledException`
      `IOException`

  - ### createOverlaySpaceAdapter

    protected DBTraceOverlaySpaceAdapter createOverlaySpaceAdapter() throws CancelledException, IOException
    Throws:
      `CancelledException`
      `IOException`

  - ### createReferenceManager

    protected DBTraceReferenceManager createReferenceManager(DBTraceThreadManager threadManager, DBTraceOverlaySpaceAdapter overlayAdapter) throws CancelledException, IOException
    Throws:
      `CancelledException`
      `IOException`

  - ### createRegisterContextManager

    protected DBTraceRegisterContextManager createRegisterContextManager(DBTraceThreadManager threadManager, DBTracePlatformManager platformManager) throws CancelledException, IOException
    Throws:
      `CancelledException`
      `IOException`

  - ### createStackManager

    protected DBTraceStackManager createStackManager(DBTraceThreadManager threadManager, DBTraceOverlaySpaceAdapter overlayAdapter) throws CancelledException, IOException
    Throws:
      `CancelledException`
      `IOException`

  - ### createStaticMappingManager

    protected DBTraceStaticMappingManager createStaticMappingManager(DBTraceOverlaySpaceAdapter overlayAdapter) throws CancelledException, IOException
    Throws:
      `CancelledException`
      `IOException`

  - ### createSymbolManager

    protected DBTraceSymbolManager createSymbolManager(DBTraceThreadManager threadManager, DBTraceDataTypeManager dataTypeManager, DBTraceOverlaySpaceAdapter overlayAdapter) throws CancelledException, IOException
    Throws:
      `CancelledException`
      `IOException`

  - ### createThreadManager

    protected DBTraceThreadManager createThreadManager(DBTraceObjectManager objectManager) throws IOException, CancelledException
    Throws:
      `IOException`
      `CancelledException`

  - ### createTimeManager

    protected DBTraceTimeManager createTimeManager(DBTraceThreadManager threadManager) throws IOException, CancelledException
    Throws:
      `IOException`
      `CancelledException`

  - ### getBaseLanguage

    public Language getBaseLanguage()
    Specified by:
      `getBaseLanguage` in interface `Trace`

  - ### getBaseCompilerSpec

    public CompilerSpec getBaseCompilerSpec()
    Specified by:
      `getBaseCompilerSpec` in interface `Trace`

  - ### setTraceUserData

    protected void setTraceUserData(DBTraceUserData traceUserData)

  - ### setChanged

    protected void setChanged(boolean b)
    Overrides:
      `setChanged` in class `DomainObjectAdapterDB`

  - ### isChangeable

    public boolean isChangeable()
    Description copied from interface: `DomainObject`
    Returns true if changes are permitted.
    Specified by:
      `isChangeable` in interface `DomainObject`
    Returns:
      true if changes are permitted.

  - ### getBaseAddressFactory

    public AddressFactory getBaseAddressFactory()
    Specified by:
      `getBaseAddressFactory` in interface `Trace`

  - ### getInternalAddressFactory

    public TraceAddressFactory getInternalAddressFactory()

  - ### getAddressPropertyManager

    public TraceAddressPropertyManager getAddressPropertyManager()
    Specified by:
      `getAddressPropertyManager` in interface `Trace`

  - ### getInternalAddressPropertyManager

    public DBTraceAddressPropertyManager getInternalAddressPropertyManager()

  - ### getBookmarkManager

    public DBTraceBookmarkManager getBookmarkManager()
    Specified by:
      `getBookmarkManager` in interface `Trace`

  - ### getBreakpointManager

    public DBTraceBreakpointManager getBreakpointManager()
    Specified by:
      `getBreakpointManager` in interface `Trace`

  - ### getCodeManager

    public DBTraceCodeManager getCodeManager()
    Specified by:
      `getCodeManager` in interface `Trace`

  - ### getCommentAdapter

    public DBTraceCommentAdapter getCommentAdapter()

  - ### getDataSettingsAdapter

    public DBTraceDataSettingsAdapter getDataSettingsAdapter()

  - ### getBaseDataTypeManager

    public DBTraceDataTypeManager getBaseDataTypeManager()
    Specified by:
      `getBaseDataTypeManager` in interface `Trace`

  - ### getEquateManager

    public DBTraceEquateManager getEquateManager()
    Specified by:
      `getEquateManager` in interface `Trace`

  - ### getPlatformManager

    public DBTracePlatformManager getPlatformManager()
    Specified by:
      `getPlatformManager` in interface `Trace`

  - ### getMemoryManager

    public DBTraceMemoryManager getMemoryManager()
    Specified by:
      `getMemoryManager` in interface `Trace`

  - ### getModuleManager

    public DBTraceModuleManager getModuleManager()
    Specified by:
      `getModuleManager` in interface `Trace`

  - ### getObjectManager

    public DBTraceObjectManager getObjectManager()
    Specified by:
      `getObjectManager` in interface `Trace`

  - ### getOverlaySpaceAdapter

    public DBTraceOverlaySpaceAdapter getOverlaySpaceAdapter()

  - ### getReferenceManager

    public DBTraceReferenceManager getReferenceManager()
    Specified by:
      `getReferenceManager` in interface `Trace`

  - ### getRegisterContextManager

    public DBTraceRegisterContextManager getRegisterContextManager()
    Specified by:
      `getRegisterContextManager` in interface `Trace`

  - ### getStackManager

    public DBTraceStackManager getStackManager()
    Specified by:
      `getStackManager` in interface `Trace`

  - ### getStaticMappingManager

    public DBTraceStaticMappingManager getStaticMappingManager()
    Specified by:
      `getStaticMappingManager` in interface `Trace`

  - ### getSymbolManager

    public DBTraceSymbolManager getSymbolManager()
    Specified by:
      `getSymbolManager` in interface `Trace`

  - ### getThreadManager

    public DBTraceThreadManager getThreadManager()
    Specified by:
      `getThreadManager` in interface `Trace`

  - ### getTimeManager

    public DBTraceTimeManager getTimeManager()
    Specified by:
      `getTimeManager` in interface `Trace`

  - ### setChanged

    public void setChanged(TraceChangeRecord<?,?> event)
    Specified by:
      `setChanged` in interface `TraceChangeManager`

  - ### fireEvent

    public void fireEvent(DomainObjectChangeRecord ev)
    Description copied from class: `DomainObjectAdapter`
    Fires the specified event.
    Overrides:
      `fireEvent` in class `DomainObjectAdapter`
    Parameters:
      `ev` - event to fire

  - ### addDirectChangeListener

    public void addDirectChangeListener(DBTraceDirectChangeListener listener)

  - ### removeDirectChangeListener

    public void removeDirectChangeListener(DBTraceDirectChangeListener listener)

  - ### getFixedProgramView

    public DBTraceProgramView getFixedProgramView(long snap)
    Specified by:
      `getFixedProgramView` in interface `Trace`

  - ### createProgramView

    public DBTraceVariableSnapProgramView createProgramView(long snap)
    Specified by:
      `createProgramView` in interface `Trace`

  - ### getProgramView

    public DBTraceVariableSnapProgramView getProgramView()
    Description copied from interface: `Trace`
    Get the "canonical" program view for this trace

    This view is the view returned, e.g., by `TraceCodeUnit.getProgram()`, no matter which view was actually used to retrieve that unit.

    Specified by:
      `getProgramView` in interface `Trace`
    Returns:
      the canonical program view

  - ### createTimeViewport

    public DBTraceTimeViewport createTimeViewport()
    Specified by:
      `createTimeViewport` in interface `Trace`

  - ### lockRead

    public LockHold lockRead()
    Specified by:
      `lockRead` in interface `Trace`

  - ### lockWrite

    public LockHold lockWrite()
    Specified by:
      `lockWrite` in interface `Trace`

  - ### sourceArchiveChanged

    public void sourceArchiveChanged(UniversalID sourceArchiveID)

  - ### sourceArchiveAdded

    public void sourceArchiveAdded(UniversalID sourceArchiveID)

  - ### dataTypeChanged

    public void dataTypeChanged(long changedID, DataType changedType)

  - ### dataTypeAdded

    public void dataTypeAdded(long addedID, DataType addedType)

  - ### dataTypeReplaced

    public void dataTypeReplaced(long replacedID, DataTypePath replacedPath, DataTypePath newPath)

  - ### dataTypeMoved

    public void dataTypeMoved(long movedID, DataTypePath oldPath, DataTypePath newPath)

  - ### dataTypeNameChanged

    public void dataTypeNameChanged(long renamedID, String oldName, String newName)

  - ### dataTypeDeleted

    public void dataTypeDeleted(long deletedID, DataTypePath deletedPath)

  - ### categoryAdded

    public void categoryAdded(long addedID, Category addedCategory)

  - ### categoryMoved

    public void categoryMoved(long movedID, CategoryPath oldPath, CategoryPath newPath)

  - ### categoryRenamed

    public void categoryRenamed(long renamedID, String oldName, String newName)

  - ### categoryDeleted

    public void categoryDeleted(long deletedID, CategoryPath deletedPath)

  - ### clearCache

    protected void clearCache(boolean all)
    Overrides:
      `clearCache` in class `DomainObjectAdapterDB`

  - ### setExecutablePath

    public void setExecutablePath(String path)

  - ### getExecutablePath

    public String getExecutablePath()

  - ### getCreationDate

    public Date getCreationDate()

  - ### setEmulatorCacheVersion

    public void setEmulatorCacheVersion(long version)
    Specified by:
      `setEmulatorCacheVersion` in interface `Trace`

  - ### getEmulatorCacheVersion

    public long getEmulatorCacheVersion()
    Specified by:
      `getEmulatorCacheVersion` in interface `Trace`

  - ### getAllProgramViews

    public Collection<TraceProgramView> getAllProgramViews()
    Description copied from interface: `Trace`
    Collect all program views, fixed or variable, of this trace.
    Specified by:
      `getAllProgramViews` in interface `Trace`
    Returns:
      the current set of program views

  - ### allViewports

    protected void allViewports(Consumer<DBTraceTimeViewport> action)

  - ### allViews

    protected void allViews(Consumer<DBTraceProgramView> action)

  - ### addProgramViewListener

    public void addProgramViewListener(Trace.TraceProgramViewListener listener)
    Specified by:
      `addProgramViewListener` in interface `Trace`

  - ### removeProgramViewListener

    public void removeProgramViewListener(Trace.TraceProgramViewListener listener)
    Specified by:
      `removeProgramViewListener` in interface `Trace`

  - ### updateViewsAddRegionBlock

    public void updateViewsAddRegionBlock(TraceMemoryRegion region)

  - ### updateViewsChangeRegionBlockName

    public void updateViewsChangeRegionBlockName(TraceMemoryRegion region)

  - ### updateViewsChangeRegionBlockFlags

    public void updateViewsChangeRegionBlockFlags(TraceMemoryRegion region, Lifespan lifespan)

  - ### updateViewsChangeRegionBlockRange

    public void updateViewsChangeRegionBlockRange(TraceMemoryRegion region, AddressRange oldRange, AddressRange newRange)

  - ### updateViewsChangeRegionBlockLifespan

    public void updateViewsChangeRegionBlockLifespan(TraceMemoryRegion region, Lifespan oldLifespan, Lifespan newLifespan)

  - ### updateViewsDeleteRegionBlock

    public void updateViewsDeleteRegionBlock(TraceMemoryRegion region)

  - ### updateViewsAddSpaceBlock

    public void updateViewsAddSpaceBlock(AddressSpace space)

  - ### updateViewsDeleteSpaceBlock

    public void updateViewsDeleteSpaceBlock(AddressSpace space)

  - ### updateViewsRefreshBlocks

    public void updateViewsRefreshBlocks()

  - ### updateViewsBytesChanged

    public void updateViewsBytesChanged(AddressRange range)

  - ### updateViewportsSnapshotAdded

    public void updateViewportsSnapshotAdded(TraceSnapshot snapshot)

  - ### updateViewportsSnapshotChanged

    public void updateViewportsSnapshotChanged(TraceSnapshot snapshot)

  - ### updateViewportsSnapshotDeleted

    public void updateViewportsSnapshotDeleted(TraceSnapshot snapshot)

  - ### save

    public void save(String comment, TaskMonitor monitor) throws IOException, CancelledException
    Description copied from interface: `DomainObject`
    Saves changes to the DomainFile.
    Specified by:
      `save` in interface `DomainObject`
    Overrides:
      `save` in class `DomainObjectAdapterDB`
    Parameters:
      `comment` - comment used for new version
      `monitor` - monitor that shows the progress of the save
    Throws:
      `IOException` - thrown if there was an error accessing this domain object
      `CancelledException` - thrown if the user canceled the save operation

  - ### saveToPackedFile

    public void saveToPackedFile(File outputFile, TaskMonitor monitor) throws IOException, CancelledException
    Description copied from interface: `DomainObject`
    Saves (i.e., serializes) the current content to a packed file.
    Specified by:
      `saveToPackedFile` in interface `DomainObject`
    Overrides:
      `saveToPackedFile` in class `DomainObjectAdapterDB`
    Parameters:
      `outputFile` - packed output file
      `monitor` - progress monitor
    Throws:
      `IOException` - if an exception occurs
      `CancelledException` - if the user cancels

  - ### isClosing

    public boolean isClosing()

  - ### close

    protected void close()
    Overrides:
      `close` in class `DomainObjectAdapterDB`

  - ### domainObjectRestored

    protected void domainObjectRestored()
    Description copied from class: `DomainObjectAdapterDB`
    Indicates that this domain object has been restored to a completely different state due to a transaction undo/redo/rollback or a database merge operation.
    Overrides:
      `domainObjectRestored` in class `DomainObjectAdapterDB`